<cfsetting enablecfoutputonly="true" />

<!--- Declare page variables. --->
<cfparam
	name="variables.cDatasource"
	type="string"
	default="mydb" /> <!--- MAKE SURE YOU CHANGE THE DATASOURCE --->

<cfparam
	name="variables.iRow"
	type="numeric"
	default="0" />

<cfparam
	name="variables.cSourceTable"
	type="string"
	default="maxrows_source" />

<cfparam
	name="variables.cTargetTable"
	type="string"
	default="maxrows_target" />

<cfparam
	name="variables.qInsert"
	type="query"
	default="#queryNew( 'empty' )#" />

<cfparam
	name="variables.qTarget"
	type="query"
	default="#queryNew( 'empty' )#" />


<!--- Table for showing the results. --->
<cfoutput>
<table border="1" cellpadding="3" cellspacing="0" border="1">
<tbody>
<tr>
	<th>Method</th>
	<th>CFQUERY returned records</th>
	<th>SQL SERVER actual records</th>
</tr>
</cfoutput>


<!--- Create the SOURCE and TARGET tables in SQL Server. --->
<cfquery datasource="#variables.cDatasource#">
	CREATE TABLE [dbo].#variables.cSourceTable# ( [ID] [int] NOT NULL );
	CREATE TABLE [dbo].#variables.cTargetTable# ( [ID] [int] NOT NULL );
</cfquery>

<!---
	Populate the SOURCE table.
	I create 100 rows for this test.
--->
<cfloop
	from="1"
	to="100"
	step="1"
	index="variables.iRow">
	
	<cfquery datasource="#variables.cDatasource#">
		INSERT INTO #variables.cSourceTable#
			(ID)
		VALUES
			( #variables.iRow# );
	</cfquery>
	
</cfloop>

   
<!---
	PART 1 / 3.
	Populate the target table without using any filters.
	No 'MAXROWS' and no 'TOP'.
--->

<!--- Make sure the target table is empty. --->
<cfquery
	datasource="#variables.cDatasource#">
		DELETE
		FROM #variables.cTargetTable#
</cfquery>

<!---
	Insert from the source table to the target.
	Output in ColdFusion the affected records.
--->
<cfquery
	datasource="#variables.cDatasource#"
	result="variables.qInsert">
		INSERT INTO #variables.cTargetTable#
		(ID) OUTPUT INSERTED.*
		SELECT ID FROM #variables.cSourceTable#
</cfquery>

<!---
	Count the actual number of records
	inserted in the target table.
--->
<cfquery
	datasource="#variables.cDatasource#"
	name="variables.qTarget">
		SELECT
			COUNT(*) AS [count]
		FROM
			#variables.cTargetTable#
</cfquery>

<cfoutput>
<tr>
	<td>Base results</td>
	<td>#variables.qInsert.recordCount#</td>
	<td>#variables.qTarget.count#</td>
</tr>
</cfoutput>


<!---
	PART 2 / 3.
	Populate the target table using the SQL Server 'TOP' attribute
	which is database specific and very efficient.
--->
<cfquery
	datasource="#variables.cDatasource#">
		DELETE FROM #variables.cTargetTable#
</cfquery>

<cfquery
	datasource="#variables.cDatasource#"
	result="variables.qInsert">
		INSERT INTO #variables.cTargetTable#
		(ID) OUTPUT INSERTED.*
		SELECT TOP 5 ID FROM #variables.cSourceTable#
</cfquery>

<cfquery
	datasource="#variables.cDatasource#"
	name="variables.qTarget">
		SELECT
			COUNT(*) AS [count]
		FROM
			#variables.cTargetTable#
</cfquery>

<cfoutput>
<tr>
	<td>Sql Server 'TOP' attribute</td>
	<td>#variables.qInsert.recordCount#</td>
	<td>#variables.qTarget.count#</td>
</tr>
</cfoutput>


<!---
	PART 3 / 3.
	Populate the target table using the ColdFusion MAXROWS attribute
	which seems to be very efficient.
--->
<cfquery
	datasource="#variables.cDatasource#">
		DELETE FROM #variables.cTargetTable#
</cfquery>

<cfquery
	datasource="#variables.cDatasource#"
	result="variables.qInsert"
	maxrows="5">
		INSERT INTO #variables.cTargetTable#
		(ID) OUTPUT INSERTED.*
		SELECT ID FROM #variables.cSourceTable#
</cfquery>

<cfquery
	datasource="#variables.cDatasource#"
	name="variables.qTarget">
		SELECT
			COUNT(*) AS [count]
		FROM
			#variables.cTargetTable#
</cfquery>

<cfoutput>
<tr>
	<td>ColdFusion 'MaxRows' attribute</td>
	<td>#variables.qInsert.recordCount#</td>
	<td>#variables.qTarget.count#</td>
</tr>
</tbody>
</table>
</cfoutput>


<!--- Drop the newly created tables to clean up the db. --->
<cfquery datasource="#variables.cDatasource#">
	DROP TABLE #variables.cSourceTable#;
	DROP TABLE #variables.cTargetTable#;
</cfquery>


<cfsetting enablecfoutputonly="false" />